<script setup lang="ts">
import { computed, h } from 'vue';
import { useRoute } from 'vue-router';
import { GLOBAL_HEADER_MENU_ID } from '@/constants/app';
import { useRouteStore } from '@/store/modules/route';
import { useRouterPush } from '@/hooks/common/router';

defineOptions({
  name: 'HorizontalMenu'
});

const route = useRoute();
const routeStore = useRouteStore();
const { routerPushByKeyWithMetaQuery } = useRouterPush();

const selectedKey = computed(() => {
  const { hideInMenu, activeMenu } = route.meta;
  const name = route.name as string;

  const routeName = (hideInMenu ? activeMenu : name) || name;

  return routeName;
});
// 自定义图标渲染函数
const renderIcon = (menuOption: any) => {
  if (!menuOption.icon) return null; // 没有图标时返回空
  const icon = String(menuOption.icons); // 确保 icon 是字符串
  if (icon.startsWith('/')) {
    // 如果图标以/开头，加上域名并以img形式展示
    const origin = window.location.origin;
    origin.split('/').slice(0, 3).join('/');
    const iconUrl = `${origin}${icon}`;
    // const iconUrl = `http://localhost:80${icon}`;

    return h('img', { src: iconUrl, alt: 'icon', class: 'menu-icon', style: 'width: 16px; height: 16px;' });
  }
  return h('i', { class: `fa ${menuOption.icons}` });
};
</script>

<template>
  <Teleport :to="`#${GLOBAL_HEADER_MENU_ID}`">
    <NMenu
      mode="horizontal"
      :value="selectedKey"
      :options="routeStore.menus"
      :indent="18"
      :render-icon="renderIcon"
      responsive
      @update:value="routerPushByKeyWithMetaQuery"
    />
  </Teleport>
</template>

<style scoped></style>
